---
title: SourceBuffer.removeAsync()
slug: Web/API/SourceBuffer/removeAsync
tags:
  - API
  - Audio
  - MSE
  - Media
  - Media Source Extensions
  - Method
  - Non-standard
  - Reference
  - SourceBuffer
  - Video
  - removeAsync
---
<div>{{APIRef("Media Source Extensions")}}{{non-standard_header}}{{SeeCompatTable}}</div>

<p><span class="seoSummary">The <code><strong>removeAsync()</strong></code> method of the {{domxref("SourceBuffer")}} interface starts the process of asynchronously removing from the <code>SourceBuffer</code> media segments found within a specific time range.</span> A {{jsxref("Promise")}} is returned, which is fulfilled when the buffers in the specified time range have been removed.</p>

<p>This method can only be called when {{domxref("SourceBuffer.updating", "updating")}} is <code>false</code>. If that's not the case, call {{domxref("SourceBuffer.abort", "abort()")}} instead.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>removePromise</em> = <em>sourceBuffer</em>.removeAsync(<em>start</em>, <em>end</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>start</code></dt>
 <dd>A double representing the start of the time range, in seconds.</dd>
 <dt><code>end</code></dt>
 <dd>A double representing the end of the time range, in seconds.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} whose fulfillment handler is executed once the buffers in the specified time range have been removed from the <code>SourceBuffer</code>.</p>

<h2 id="Example">Example</h2>

<p>This example establishes an asynchronous function, <code>emptySourceBuffer()</code>, which clears the contents of the specified <code>SourceBuffer</code>.</p>

<pre class="brush: js">async function emptySourceBuffer(msBuffer) {
  await msBuffer.removeAsync(0, Infinity).catch(function(e) {
    handleException(e);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<p>Not currently part of the MSE specification.</p>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.removeAsync")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Source_Extensions_API">Media Source Extensions API</a></li>
 <li>{{domxref("SourceBuffer.remove()")}}</li>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
